#+title: The Helm Classes Manual
# #+subtitle:  Release {{{version}}}
#+subtitle:  Release 3.6.2
#+author:    The Helm Classes Developers
# #+date:      {{{modification-time}}}
#+language:  en

# #+texinfo: @insertcopying

#+texinfo: @defindex hc

* Table Of Contents                                                     :TOC_4:

* Overview of Helm Classes

[[./helm-figures/helm-classes.png]]

* class: helm-source

Main interface to define helm sources.

[[./helm-figures/helm-source.png]]

#+hcindex: helm-source

#+hcindex: helm-bookmark-override-inheritor

#+hcindex: helm-type-timers

#+hcindex: helm-type-command

#+hcindex: helm-type-function

#+hcindex: helm-type-buffer

#+hcindex: helm-type-bookmark

#+hcindex: helm-type-file

#+hcindex: helm-source-dummy

#+hcindex: helm-source-in-buffer

#+hcindex: helm-source-async

#+hcindex: helm-source-sync

- *parents* ::

- *children* ::

  - [[*class: helm-bookmark-override-inheritor]]

  - [[*class: helm-type-timers]]

  - [[*class: helm-type-command]]

  - [[*class: helm-type-function]]

  - [[*class: helm-type-buffer]]

  - [[*class: helm-type-bookmark]]

  - [[*class: helm-type-file]]

  - [[*class: helm-source-dummy]]

  - [[*class: helm-source-in-buffer]]

  - [[*class: helm-source-async]]

  - [[*class: helm-source-sync]]

This class has following slots.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Function called with no parameters when helm is started.
    It is useful for collecting current state information which can be
    used to create the list of candidates later.
    Initialization of ~candidates-in-buffer~ is done here
    with ~helm-init-candidates-in-buffer~.

** name
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    The name of the source.
    A string which is also the heading which appears
    above the list of matches from the source. Must be unique.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'identity

- :documentation

    An alist of (DISPLAY . FUNCTION) pairs, a variable name  or a function.
    FUNCTION is called with one parameter: the selected candidate.

    An action other than the default can be chosen from this list
    of actions for the currently selected candidate (by default
    with TAB). The DISPLAY string is shown in the completions
    buffer and the FUNCTION is invoked when an action is
    selected. The first action of the list is the default.

    You should use ~helm-make-actions~ to build this alist easily.

** action-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    It's a function or a list of functions called with two
    arguments when the action list from the source is
    assembled. The first argument is the list of actions, the
    second is the current selection.  If it is a list of functions,
    it calls each function sequentially.

    The function should return a transformed action list.

    This can be used to customize the list of actions based on the
    currently selected candidate.

** after-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A local hook that run at end of initilization of this source.
    i.e After the creation of ~helm-buffer~.

    Should be a variable.
    Can be also an anonymous function or a list of functions
    directly added to slot, this is not recommended though.

** allow-dups
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Allow helm collecting duplicates candidates.

** before-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A local hook that run at beginning of initilization of this source.
    i.e Before the creation of ~helm-buffer~.

    Should be a variable (defined with defvar).
    Can be also an anonymous function or a list of functions
    directly added to slot, this is not recommended though.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Override ~helm-candidate-number-limit~ only for this source.

** candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    It's a function or a list of functions called with one argument
    when the completion list from the source is built. The argument
    is the list of candidates retrieved from the source. The
    function should return a transformed list of candidates which
    will be used for the actual completion.  If it is a list of
    functions, it calls each function sequentially.

    This can be used to transform or remove items from the list of
    candidates.

    Note that ~candidates~ is run already, so the given transformer
    function should also be able to handle candidates with (DISPLAY
    . REAL) format.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Specifies how to retrieve candidates from the source.
    It can either be a variable name, a function called with no parameters
    or the actual list of candidates.

    Do NOT use this for asynchronous sources, use ~candidates-process~
    instead.

    The list must be a list whose members are strings, symbols
    or (DISPLAY . REAL) pairs.

    In case of (DISPLAY . REAL) pairs, the DISPLAY string is shown
    in the Helm buffer, but the REAL one is used as action
    argument when the candidate is selected. This allows a more
    readable presentation for candidates which would otherwise be,
    for example, too long or have a common part shared with other
    candidates which can be safely replaced with an abbreviated
    string for display purposes.

    Note that if the (DISPLAY . REAL) form is used then pattern
    matching is done on the displayed string, not on the real
    value.

    This function, generally should not compute candidates according to
    ~helm-pattern~ which defeat all the Helm's matching mechanism
    i.e. multiple pattern matching and/or fuzzy matching.
    If you want to do so, use :match-dynamic slot to be sure matching
    occur only in :candidates function and there is no conflict with
    other match functions.

** cleanup
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Function called with no parameters when *helm* buffer is
    closed. It is useful for killing unneeded candidates buffer.

    Note that the function is executed BEFORE performing action.

** coerce
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    It's a function called with one argument: the selected candidate.
    This function is intended for type convertion. In normal case,
    the selected candidate (string) is passed to action
    function. If coerce function is specified, it is called just
    before action function.

    Example: converting string to symbol
      (coerce . intern)

** delayed
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    This slot have no more effect and is just kept for backward compatibility.
    Please don't use it.

** display-to-real
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Transform the selected candidate when passing it to action.

    Function called with one parameter, the selected candidate.

    Avoid recomputing all candidates with candidate-transformer
    or filtered-candidate-transformer to give a new value to REAL,
    instead the selected candidate is transformed only when passing it
    to action.
    Example:

      (helm :sources (helm-build-sync-source "test"
		   :candidates '(a b c d e)
		   :display-to-real (lambda (c) (concat c ":modified by d-t-r")))
	:buffer "*helm test*")

    Note that this is NOT a transformer,
    so the display will not be modified by this function.

** filter-one-by-one
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A transformer function that treat candidates one by one.
    It is called with one arg the candidate.
    It is faster than ~filtered-candidate-transformer~ or
    ~candidate-transformer~, but should be used only in sources
    that recompute constantly their candidates, e.g ~helm-source-find-files~.
    Filtering happen early and candidates are treated
    one by one instead of re-looping on the whole list.
    If used with ~filtered-candidate-transformer~ or ~candidate-transformer~
    these functions should treat the candidates transformed by the
    ~filter-one-by-one~ function in consequence.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    It has the same format as ~candidate-transformer~, except the
    function is called with two parameters: the candidate list and
    the source.

    This transformer is run on the candidate list which is already
    filtered by the current pattern. While ~candidate-transformer~
    is run only once, it is run every time the input pattern is
    changed.

    It can be used to transform the candidate list dynamically, for
    example, based on the current pattern.

    In some cases it may also be more efficent to perform candidate
    transformation here, instead of with ~candidate-transformer~
    even if this transformation is done every time the pattern is
    changed.  For example, if a candidate set is very large then
    ~candidate-transformer~ transforms every candidate while only
    some of them will actually be displayed due to the limit
    imposed by ~helm-candidate-number-limit~.

    Note that ~candidates~ and ~candidate-transformer~ is run
    already, so the given transformer function should also be able
    to handle candidates with (DISPLAY . REAL) format.

** follow
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Enable ~helm-follow-mode~ for this source only.
    With a value of 1 enable, a value of -1 or nil disable the mode.
    See ~helm-follow-mode~ for more infos.

** follow-delay
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    ~helm-follow-mode~ will execute persistent-action after this delay.
    Otherwise value of ~helm-follow-input-idle-delay~ is used if non--nil,
    If none of these are found fallback to ~helm-input-idle-delay~.

** fuzzy-match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Enable fuzzy matching in this source.
    This will overwrite settings in MATCH slot, and for
    sources built with child class ~helm-source-in-buffer~ the SEARCH slot.
    This is an easy way of enabling fuzzy matching, but you can use the MATCH
    or SEARCH slots yourself if you want something more elaborated, mixing
    different type of match (See ~helm-source-buffers~ class for example).

    This attribute is not supported for asynchronous sources
    since they perform pattern matching themselves.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm

- :documentation

    The current source group, default to ~helm~ when not specified.

** header-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Source local ~header-line-format~.
    It will be displayed in ~header-line~ or in ~minibuffer~ depending
    of value of ~helm-echo-input-in-header-line~ and ~helm-display-header-line~.
    It accepts also variable/function name.

** header-name
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A function returning the display string of the header.
    Its argument is the name of the source. This attribute is useful to
    add an additional information with the source name.
    It doesn't modify the name of the source.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Help message for this source.
    If not present, ~helm-help-message~ value will be used.

** history
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Allow passing history variable to helm from source.
    It should be a quoted symbol.
    Passing the history variable here have no effect
    so add it also in the ~helm~ call with the :history keyword.
    The main point of adding the variable here
    is to make it available when resuming.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-map

- :documentation

    Specific keymap for this source.
    default value is ~helm-map~.

** marked-with-props
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Get candidates with their properties in ~helm-marked-candidates~.
    Allow using the FORCE-DISPLAY-PART of ~helm-get-selection~ in marked
    candidates, use t or 'withprop to pass it to ~helm-get-selection~.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    List of functions called with one parameter: a candidate. The
    function should return non-nil if the candidate matches the
    current pattern (see variable ~helm-pattern~).

    When using ~candidates-in-buffer~ its default value is ~identity~ and
    don't have to be changed, use the ~search~ slot instead.

    This attribute allows the source to override the default
    pattern matching based on ~string-match~. It can be used, for
    example, to implement a source for file names and do the
    pattern matching on the basename of files, since it's more
    likely one is typing part of the basename when searching for a
    file, instead of some string anywhere else in its path.

    If the list contains more than one function then the list of
    matching candidates from the source is constructed by appending
    the results after invoking the first function on all the
    potential candidates, then the next function, and so on. The
    matching candidates supplied by the first function appear first
    in the list of results and then results from the other
    functions, respectively.

    This attribute has no effect for asynchronous sources (see
    attribute ~candidates~), and sources using ~match-dynamic~
    since they perform pattern matching themselves.

    Note that FUZZY-MATCH slot will overhide value of this slot.

** match-on-real
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Match the real value of candidates when non nil.

** match-part
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Allow matching only one part of candidate.
    If source contain match-part attribute, match is computed only
    on part of candidate returned by the call of function provided
    by this attribute. The function should have one arg, candidate,
    and return only a specific part of candidate.
    On async sources, as matching is done by the backend, this have
    no effect apart for highlighting matches.

** mode-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Source local ~helm-mode-line-string~ (included in
    ~mode-line-format~). It accepts also variable/function name.

** multiline
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Allow multiline candidates.
    When non-nil candidates will be separated by ~helm-candidate-separator~.
    You can customize the color of this separator with ~helm-separator~ face.
    Value of multiline can be an integer which specify the maximum size of the
    multiline string to display, if multiline string is longer than this value
    it will be truncated.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

    Use the multi-match algorithm when non-nil.
    I.e Allow specifying multiple patterns separated by spaces.
    When a pattern is prefixed by "!" the negation of this pattern is used,
    i.e match anything but this pattern.
    It is the standard way of matching in helm and is enabled by default.
    It can be used with fuzzy-matching enabled, but as soon helm detect a space,
    each pattern will match by regexp and will not be fuzzy.

** must-match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Same as ~completing-read~ require-match arg.
    Possible values are:
    - ~t~ which prevent exiting with an empty helm-buffer i.e. no matches.
    - ~confirm~ which ask for confirmation i.e. need to press a second
       time RET.
    - ~nil~ is the default and is doing nothing i.e. returns nil when
      pressing RET with an empty helm-buffer.
    - Any other non nil values e.g. ~ignore~ allow exiting with
      minibuffer contents as candidate value (in this case helm-buffer
      is empty).

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Disable highlighting matches in this source.
    This will disable generic highlighting of matches,
    but some specialized highlighting can be done from elsewhere,
    i.e from ~filtered-candidate-transformer~ or ~filter-one-by-one~ slots.
    So use this to either disable completely highlighting in your source,
    or to disable highlighting and use a specialized highlighting matches
    function for this source.
    Remember that this function should run AFTER all filter functions if those
    filter functions are modifying face properties, though it is possible to
    avoid this by using new ~add-face-text-property~ in your filter functions.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Don't allow marking candidates when this attribute is present.

** pattern-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    It's a function or a list of functions called with one argument
    before computing matches. Its argument is ~helm-pattern~.
    Functions should return transformed ~helm-pattern~.

    It is useful to change interpretation of ~helm-pattern~.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Can be a either a Function called with one parameter (the
    selected candidate) or a cons cell where first element is this
    same function and second element a symbol (e.g never-split)
    that inform ~helm-execute-persistent-action~ to not split his
    window to execute this persistent action.
    Example:

      (defun foo-persistent-action (candidate)
	 (do-something candidate))

      :persistent-action '(foo-persistent-action . never-split) ; Don't split
    or
      :persistent-action 'foo-persistent-action ; Split

    When specifying :persistent-action by slot directly, foo-persistent-action
    will be executed without quitting helm when hitting ~C-j~.

    Note that other persistent actions can be defined using other
    bindings than ~C-j~ by simply defining an interactive function bound
    to a key in the keymap source.
    The function should create a new attribute in source before calling
    ~helm-execute-persistent-action~ on this attribute.
    Example:

       (defun helm-ff-persistent-delete ()
	 "Delete current candidate without quitting."
	 (interactive)
	 (with-helm-alive-p
	   (helm-set-attr 'quick-delete '(helm-ff-quick-delete . never-split))
	   (helm-execute-persistent-action 'quick-delete)))

    This function is then bound in ~helm-find-files-map~.

** persistent-action-if
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Similar from persistent action but it is a function that should
    return an object suitable for persistent action when called , i.e. a
    function or a cons cell.
    Example:

       (defun foo-persistent-action (candidate)
	 (cond (something
		;; Don't split helm-window.
		(cons (lambda (_ignore)
			(do-something candidate))
		      'no-split))
	       ;; Split helm-window.
	       (something-else
		(lambda (_ignore)
		  (do-something-else candidate)))))

       :persistent-action-if 'foo-persistent-action

    Here when hitting ~C-j~ one of the lambda's will be executed
    depending on something or something-else condition, splitting or not
    splitting as needed.
    See ~helm-find-files-persistent-action-if~ definition as another example.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A string to explain persistent-action of this source. It also
    accepts a function or a variable name.
    It will be displayed in ~header-line~ or in ~minibuffer~ depending
    of value of ~helm-echo-input-in-header-line~ and ~helm-display-header-line~.

** real-to-display
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Recompute all candidates computed previously with other transformers.

    Function called with one parameter, the selected candidate.

    The real value of candidates will be shown in display and of course
    be used by action.
    Example:

      (helm :sources (helm-build-sync-source "test"
		   :candidates '(("foo" . 1) ("bar" . 2) ("baz". 3))
		   :real-to-display (lambda (c) (format "%s" (1+ c))))
	:buffer "*helm test*")

    Mostly deprecated, kept only for backward compatibility.

** redisplay
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'identity

- :documentation

    A function or a list of functions to apply to current list
    of candidates when redisplaying buffer with ~helm-redisplay-buffer~.
    This is only interesting for modifying and redisplaying the whole list
    of candidates in async sources.
    It uses ~identity~ by default for when async sources are mixed with
    normal sources, in this case these normal sources are not modified and
    redisplayed as they are.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  0

- :documentation

    If present matches from the source are shown only if the
    pattern is not empty. Optionally, it can have an integer
    parameter specifying the required length of input which is
    useful in case of sources with lots of candidates.

** resume
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Function called with no parameters at end of initialization
    when ~helm-resume~ is started.
    If this function try to do something against ~helm-buffer~, (e.g updating,
    searching etc...) probably you should run it in a timer to ensure
    ~helm-buffer~ is ready.

** update
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Function called with no parameters at before "init" function
    when ~helm-force-update~ is called.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Indicates the source assembles the candidate list dynamically,
    so it shouldn't be cached within a single Helm
    invocation. It is only applicable to synchronous sources,
    because asynchronous sources are not cached.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-sync

Use this class to make helm sources using a list of candidates.
This list should be given as a normal list, a variable handling a list
or a function returning a list.
Matching is done basically with ~string-match~ against each candidate.

[[./helm-figures/helm-source-sync.png]]

#+hcindex: helm-source-sync

#+hcindex: helm-source

#+hcindex: helm-source-session-class

#+hcindex: helm-files-dired-source

#+hcindex: helm-imenu-source

#+hcindex: helm-files-in-current-dir-source

#+hcindex: helm-recentf-source

#+hcindex: helm-eshell-history-source

#+hcindex: helm-esh-source

#+hcindex: helm-epa

#+hcindex: helm-M-x-class

#+hcindex: helm-idle-time-timers-class

#+hcindex: helm-absolute-time-timers-class

#+hcindex: helm-source-ffiles

#+hcindex: helm-source-buffers

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-source-session-class]]

  - [[*class: helm-files-dired-source]]

  - [[*class: helm-imenu-source]]

  - [[*class: helm-files-in-current-dir-source]]

  - [[*class: helm-recentf-source]]

  - [[*class: helm-eshell-history-source]]

  - [[*class: helm-esh-source]]

  - [[*class: helm-epa]]

  - [[*class: helm-M-x-class]]

  - [[*class: helm-idle-time-timers-class]]

  - [[*class: helm-absolute-time-timers-class]]

  - [[*class: helm-source-ffiles]]

  - [[*class: helm-source-buffers]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '("ERROR: You must specify the ~candidates~ slot, either with a list or a function")

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Disable all helm matching functions when non nil.
    The :candidates function in this case is in charge of fetching
    candidates dynamically according to ~helm-pattern~.
    Note that :volatile is automatically enabled when using this, so no
    need to specify it.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    When specifying a match function within a source and
    helm-multi-match is enabled, the result of all matching
    functions will be concatened, which in some cases is not what
    is wanted. When using ~match-strict~ only this or these
    functions will be used. You can specify those functions as a
    list of functions or a single symbol function.

    NOTE: This have the same effect as using :MULTIMATCH nil.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Enable migemo.
    When multimatch is disabled, you can give the symbol 'nomultimatch as value
    to force not using generic migemo matching function.
    In this case you have to provide your own migemo matching funtion
    that kick in when ~helm-migemo-mode~ is enabled.
    Otherwise it will be available for this source once ~helm-migemo-mode~
    is enabled when non-nil.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-async

Use this class to define a helm source calling an external process.
The external process is called typically in a ~start-process~ call to be
asynchronous.

Note that using multiples asynchronous sources is not fully working,
expect weird behavior if you try this.

The :candidates slot is not allowed even if described because this class
inherit from ~helm-source~.

[[./helm-figures/helm-source-async.png]]

#+hcindex: helm-source-async

#+hcindex: helm-source

#+hcindex: helm-mac-spotlight-source

#+hcindex: helm-gid-source

#+hcindex: helm-fd-class

#+hcindex: helm-locate-source

#+hcindex: helm-grep-ag-class

#+hcindex: helm-grep-class

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-mac-spotlight-source]]

  - [[*class: helm-gid-source]]

  - [[*class: helm-fd-class]]

  - [[*class: helm-locate-source]]

  - [[*class: helm-grep-ag-class]]

  - [[*class: helm-grep-class]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    This attribute is used to define a process as candidate.
    The function called with no arguments must return a process
    i.e. ~processp~, it use typically ~start-process~ or ~make-process~,
    see (info "(elisp) Asynchronous Processes").

    NOTE:
    When building the source at runtime you can give directly a process
    as value, otherwise wrap the process call into a function.
    The process buffer should be nil, otherwise, if you use
    ~helm-buffer~ give to the process a sentinel.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-in-buffer

Use this source to make helm sources storing candidates inside a buffer.

The buffer storing candidates is generated by ~helm-candidate-buffer~ function
and all search are done in this buffer, results are transfered to the ~helm-buffer~
when done.
Contrarily to ~helm-source-sync~ candidates are matched using a function
like ~re-search-forward~ (see below documentation of ~:search~ slot) which makes
the search much faster than matching candidates one by one.
If you want to add search functions to your sources, don't use ~:match~ which
will raise an error, but ~:search~.
See ~helm-candidates-in-buffer~ for more infos.

[[./helm-figures/helm-source-in-buffer.png]]

#+hcindex: helm-source-in-buffer

#+hcindex: helm-source

#+hcindex: helm-semantic-source

#+hcindex: helm-file-cache

#+hcindex: helm-list-el-package-source

#+hcindex: helm-source-filtered-bookmarks

#+hcindex: helm-source-basic-bookmarks

#+hcindex: helm-info-source

#+hcindex: helm-browse-project-source

#+hcindex: helm-moccur-class

#+hcindex: helm-locate-subdirs-source

#+hcindex: helm-source-in-file

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-semantic-source]]

  - [[*class: helm-file-cache]]

  - [[*class: helm-list-el-package-source]]

  - [[*class: helm-source-filtered-bookmarks]]

  - [[*class: helm-source-basic-bookmarks]]

  - [[*class: helm-info-source]]

  - [[*class: helm-browse-project-source]]

  - [[*class: helm-moccur-class]]

  - [[*class: helm-locate-subdirs-source]]

  - [[*class: helm-source-in-file]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-default-init-source-in-buffer-function

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A string, a list or a buffer that will be used to feed the ~helm-candidates-buffer~.
    This data will be passed in a function added to the init slot and
    the buffer will be build with ~helm-init-candidates-in-buffer~ or directly
    with ~helm-candidates-buffer~ if data is a buffer.
    This is an easy and fast method to build a ~candidates-in-buffer~ source.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

    A function like ~buffer-substring-no-properties~ or ~buffer-substring~.
    This function converts region from point at line-beginning and point
    at line-end in the ~helm-candidate-buffer~ to a string which will be displayed
    in the ~helm-buffer~, it takes two args BEG and END.
    By default, ~helm-candidates-in-buffer~ uses
    ~buffer-substring-no-properties~ which does no conversion and doesn't carry
    text properties.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Enable migemo.
    When multimatch is disabled, you can give the symbol 'nomultimatch as value
    to force not using generic migemo matching function.
    In this case you have to provide your own migemo matching funtion
    that kick in when ~helm-migemo-mode~ is enabled.
    Otherwise it will be available for this source once ~helm-migemo-mode~
    is enabled when non-nil.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

    List of functions like ~re-search-forward~ or ~search-forward~.
    Buffer search function used by ~helm-candidates-in-buffer~.
    By default, ~helm-candidates-in-buffer~ uses ~re-search-forward~.
    The function should take one arg PATTERN.
    If your search function needs to handle negation like multimatch,
    this function should returns in such case a cons cell of two integers defining
    the beg and end positions to match in the line previously matched by
    ~re-search-forward~ or similar, and move point to next line
    (See how the ~helm-mm-3-search-base~ and ~helm-fuzzy-search~ functions are working).

    NOTE: FUZZY-MATCH slot will overhide value of this slot.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    When specifying a search function within a source and
    helm-multi-match is enabled, the result of all searching
    functions will be concatened, which in some cases is not what
    is wanted. When using ~search-strict~ only this or these
    functions will be used. You can specify those functions as a
    list of functions or a single symbol function.

    NOTE: This have the same effect as using a nil value for
	  :MULTIMATCH slot.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-dummy

[[./helm-figures/helm-source-dummy.png]]

#+hcindex: helm-source-dummy

#+hcindex: helm-source

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** accept-empty
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

    Allow exiting with an empty string.
    You should keep the default value.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '("dummy")

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (_candidates _source)
      (list helm-pattern))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'identity

- :documentation

  See parent class for this slot's documentation.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-dummy))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-in-file

The contents of the FILE will be used as candidates in buffer.

[[./helm-figures/helm-source-in-file.png]]

#+hcindex: helm-source-in-file

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (let
	  ((file
	    (helm-get-attr 'candidates-file))
	   (count 1))
	(with-current-buffer
	    (helm-candidate-buffer 'global)
	  (insert-file-contents file)
	  (goto-char
	   (point-min))
	  (while
	      (not
	       (eobp))
	    (add-text-properties
	     (point-at-bol)
	     (point-at-eol)
	     `(helm-linum ,count))
	    (cl-incf count)
	    (forward-line 1)))))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates-file
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    A filename.
    Each line number of FILE is accessible with helm-linum property
    from candidate display part.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'buffer-substring

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-file

A class to define helm type file.

[[./helm-figures/helm-type-file.png]]

#+hcindex: helm-type-file

#+hcindex: helm-source

#+hcindex: helm-mac-spotlight-source

#+hcindex: helm-files-dired-source

#+hcindex: helm-files-in-current-dir-source

#+hcindex: helm-recentf-source

#+hcindex: helm-file-cache

#+hcindex: helm-browse-project-override-inheritor

#+hcindex: helm-locate-override-inheritor

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-mac-spotlight-source]]

  - [[*class: helm-files-dired-source]]

  - [[*class: helm-files-in-current-dir-source]]

  - [[*class: helm-recentf-source]]

  - [[*class: helm-file-cache]]

  - [[*class: helm-browse-project-override-inheritor]]

  - [[*class: helm-locate-override-inheritor]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-file))
 :before ((source helm-type-file))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-bookmark

A class to define type bookmarks.

[[./helm-figures/helm-type-bookmark.png]]

#+hcindex: helm-type-bookmark

#+hcindex: helm-source

#+hcindex: helm-source-filtered-bookmarks

#+hcindex: helm-source-basic-bookmarks

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-source-filtered-bookmarks]]

  - [[*class: helm-source-basic-bookmarks]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-bookmark))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-bookmark))
 :before ((source helm-type-bookmark))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-buffer

A class to define type buffer.

[[./helm-figures/helm-type-buffer.png]]

#+hcindex: helm-type-buffer

#+hcindex: helm-source

#+hcindex: helm-source-buffers

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-source-buffers]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-buffer))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-buffer))
 :before ((source helm-type-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-function

A class to define helm type function.

[[./helm-figures/helm-type-function.png]]

#+hcindex: helm-type-function

#+hcindex: helm-source

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-function))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-function))
 :before ((source helm-type-function))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-command

A class to define helm type command.

[[./helm-figures/helm-type-command.png]]

#+hcindex: helm-type-command

#+hcindex: helm-source

#+hcindex: helm-M-x-class

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-M-x-class]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-command))
 :before ((source helm-type-command))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-type-timers

A class to define helm type timers.

[[./helm-figures/helm-type-timers.png]]

#+hcindex: helm-type-timers

#+hcindex: helm-source

#+hcindex: helm-idle-time-timers-class

#+hcindex: helm-absolute-time-timers-class

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-idle-time-timers-class]]

  - [[*class: helm-absolute-time-timers-class]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-timers))
 :before ((source helm-type-timers))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-files-dired-source

[[./helm-figures/helm-files-dired-source.png]]

#+hcindex: helm-files-dired-source

#+hcindex: helm-source-sync

#+hcindex: helm-type-file

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-file]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-files-in-all-dired-candidates

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-file))
 :before ((source helm-type-file))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-session-class

[[./helm-figures/helm-source-session-class.png]]

#+hcindex: helm-source-session-class

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-type-file-actions

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (cl-delete-if-not
       (lambda
	 (f)
	 (or
	  (string-match helm-tramp-file-name-regexp f)
	  (file-exists-p f)))
       (mapcar 'car session-file-alist)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-generic-file-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-generic-files-map

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-mac-spotlight-source

[[./helm-figures/helm-mac-spotlight-source.png]]

#+hcindex: helm-mac-spotlight-source

#+hcindex: helm-source-async

#+hcindex: helm-type-file

- *parents* ::

  - [[*class: helm-source-async]]

  - [[*class: helm-type-file]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (start-process "mdfind-process" nil "mdfind" helm-pattern))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  3

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))
 ((source helm-type-file))
 :before ((source helm-type-file))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-basic-bookmarks

[[./helm-figures/helm-source-basic-bookmarks.png]]

#+hcindex: helm-source-basic-bookmarks

#+hcindex: helm-source-in-buffer

#+hcindex: helm-type-bookmark

- *parents* ::

  - [[*class: helm-source-in-buffer]]

  - [[*class: helm-type-bookmark]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (bookmark-maybe-load-default-file)
      (helm-init-candidates-in-buffer 'global
	(bookmark-all-names)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-bookmark-transformer

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

  See parent class for this slot's documentation.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-bookmark))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))
 ((source helm-type-bookmark))
 :before ((source helm-type-bookmark))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-filtered-bookmarks

[[./helm-figures/helm-source-filtered-bookmarks.png]]

#+hcindex: helm-source-filtered-bookmarks

#+hcindex: helm-source-in-buffer

#+hcindex: helm-type-bookmark

#+hcindex: helm-bookmark-find-files-class

- *parents* ::

  - [[*class: helm-source-in-buffer]]

  - [[*class: helm-type-bookmark]]

- *children* ::

  - [[*class: helm-bookmark-find-files-class]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-default-init-source-in-buffer-function

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-adaptive-sort helm-highlight-bookmark)

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

  See parent class for this slot's documentation.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-bookmark))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))
 ((source helm-type-bookmark))
 :before ((source helm-type-bookmark))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-bookmark-override-inheritor

[[./helm-figures/helm-bookmark-override-inheritor.png]]

#+hcindex: helm-bookmark-override-inheritor

#+hcindex: helm-source

#+hcindex: helm-bookmark-find-files-class

- *parents* ::

  - [[*class: helm-source]]

- *children* ::

  - [[*class: helm-bookmark-find-files-class]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-bookmark-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-bookmark-find-files-class

[[./helm-figures/helm-bookmark-find-files-class.png]]

#+hcindex: helm-bookmark-find-files-class

#+hcindex: helm-source-filtered-bookmarks

#+hcindex: helm-bookmark-override-inheritor

- *parents* ::

  - [[*class: helm-source-filtered-bookmarks]]

  - [[*class: helm-bookmark-override-inheritor]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-default-init-source-in-buffer-function

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-adaptive-sort helm-highlight-bookmark)

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

  See parent class for this slot's documentation.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-bookmark))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))
 ((source helm-type-bookmark))
 :before ((source helm-type-bookmark))
 ((source helm-bookmark-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-buffers

[[./helm-figures/helm-source-buffers.png]]

#+hcindex: helm-source-buffers

#+hcindex: helm-source-sync

#+hcindex: helm-type-buffer

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-buffers-list--init

- :documentation

  See parent class for this slot's documentation.

** buffer-list
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-buffer-list

- :documentation

    A function with no arguments to create buffer list.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '("ERROR: You must specify the ~candidates~ slot, either with a list or a function")

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-buffer-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-buffer-map

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-buffers-match-function

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'nomultimatch

- :documentation

  See parent class for this slot's documentation.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-buffers-list-persistent-action

- :documentation

  See parent class for this slot's documentation.

** resume
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (setq helm-buffers-in-project-p nil))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-buffer))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-buffer))
 :before ((source helm-type-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-M-x-class

[[./helm-figures/helm-M-x-class.png]]

#+hcindex: helm-M-x-class

#+hcindex: helm-source-sync

#+hcindex: helm-type-command

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-command]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '("ERROR: You must specify the ~candidates~ slot, either with a list or a function")

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-M-x-transformer-no-sort

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-M-x-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-M-x-map

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** must-match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Describe this command"

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-command))
 :before ((source helm-type-command))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-absolute-time-timers-class

[[./helm-figures/helm-absolute-time-timers-class.png]]

#+hcindex: helm-absolute-time-timers-class

#+hcindex: helm-source-sync

#+hcindex: helm-type-timers

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-timers]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** allow-dups
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (candidates)
      (cl-loop for timer in candidates collect
	       (cons
		(helm-elisp--format-timer timer)
		timer)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  timer-list

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-timers))
 :before ((source helm-type-timers))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-idle-time-timers-class

[[./helm-figures/helm-idle-time-timers-class.png]]

#+hcindex: helm-idle-time-timers-class

#+hcindex: helm-source-sync

#+hcindex: helm-type-timers

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-timers]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** allow-dups
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (candidates)
      (cl-loop for timer in candidates collect
	       (cons
		(helm-elisp--format-timer timer)
		timer)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  timer-idle-list

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-timers))
 :before ((source helm-type-timers))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-list-el-package-source

[[./helm-figures/helm-list-el-package-source.png]]

#+hcindex: helm-list-el-package-source

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package--init

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(("Describe package" . helm-el-package-describe) ("Visit homepage" . helm-el-package-visit-homepage))

- :documentation

  See parent class for this slot's documentation.

** action-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package--action-transformer

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  9999

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package--transformer

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-el-package-map

- :documentation

  See parent class for this slot's documentation.

** update
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-el-package--update

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-epa

Allow building helm sources for GPG keys.

[[./helm-figures/helm-epa.png]]

#+hcindex: helm-epa

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (require 'epg)
      (require 'epa))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-epa-get-key-list

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-comp-read-map

- :documentation

  See parent class for this slot's documentation.

** mode-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-comp-read-mode-line

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-esh-source

Helm class to define source for Eshell completion.

[[./helm-figures/helm-esh-source.png]]

#+hcindex: helm-esh-source

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (setq pcomplete-current-completions nil pcomplete-last-completion-raw nil)
      (remove-hook 'minibuffer-setup-hook 'eshell-mode))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-ec-insert

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-esh-get-candidates

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-esh-transformer

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'ignore

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-eshell-history-source

Helm class to define source for Eshell history.

[[./helm-figures/helm-eshell-history-source.png]]

#+hcindex: helm-eshell-history-source

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (remove-hook 'minibuffer-setup-hook 'eshell-mode))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (candidate)
      (eshell-kill-input)
      (insert candidate))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  9999

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (with-helm-current-buffer
	(cl-loop for c from 0 to
		 (ring-length eshell-history-ring)
		 for elm =
		 (eshell-get-history c)
		 unless
		 (and
		  (member elm lst)
		  eshell-hist-ignoredups)
		 collect elm into lst finally return lst)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-eshell-history-map

- :documentation

  See parent class for this slot's documentation.

** multiline
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-fd-class

[[./helm-figures/helm-fd-class.png]]

#+hcindex: helm-fd-class

#+hcindex: helm-source-async

- *parents* ::

  - [[*class: helm-source-async]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-type-file-actions

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  20000

- :documentation

  See parent class for this slot's documentation.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-fd-process

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-fd-fct

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-fd-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-fd-map

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  2

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-source-ffiles

[[./helm-figures/helm-source-ffiles.png]]

#+hcindex: helm-source-ffiles

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (setq helm-ff-auto-update-flag helm-ff-auto-update-initial-value)
      (setq helm-ff--auto-update-state helm-ff-auto-update-flag)
      (helm-set-local-variable 'bookmark-make-record-function #'helm-ff-make-bookmark-record)
      (require 'helm-external))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-actions

- :documentation

  See parent class for this slot's documentation.

** action-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-action-transformer

- :documentation

  See parent class for this slot's documentation.

** after-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-after-init-hook

- :documentation

  See parent class for this slot's documentation.

** before-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-before-init-hook

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-ff-candidate-number-limit

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-get-candidates

- :documentation

  See parent class for this slot's documentation.

** cleanup
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-cleanup

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-ff-fct helm-ff-directories-only helm-ff-files-only helm-ff-sort-candidates)

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-files

- :documentation

  See parent class for this slot's documentation.

** header-name
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (name)
      (concat name
	      (substitute-command-keys helm-find-files-doc-header)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-ff-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-find-files-map

- :documentation

  See parent class for this slot's documentation.

** match-on-real
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** mode-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (list "File(s)" helm-mode-line-string)
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-action-if
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-find-files-persistent-action-if

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Hit1 Expand Candidate, Hit2 or (C-u) Find file"

- :documentation

  See parent class for this slot's documentation.

** update
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (remhash helm-ff-default-directory helm-ff--list-directory-cache))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-browse-project-override-inheritor

[[./helm-figures/helm-browse-project-override-inheritor.png]]

#+hcindex: helm-browse-project-override-inheritor

#+hcindex: helm-type-file

#+hcindex: helm-browse-project-source

- *parents* ::

  - [[*class: helm-type-file]]

- *children* ::

  - [[*class: helm-browse-project-source]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-file))
 :before ((source helm-type-file))
 :after ((source helm-browse-project-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-browse-project-source

Class to define a source in ~helm-browse-project~ handling non
VC handled directories.

[[./helm-figures/helm-browse-project-source.png]]

#+hcindex: helm-browse-project-source

#+hcindex: helm-source-in-buffer

#+hcindex: helm-browse-project-override-inheritor

- *parents* ::

  - [[*class: helm-source-in-buffer]]

  - [[*class: helm-browse-project-override-inheritor]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-default-init-source-in-buffer-function

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** filter-one-by-one
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (c)
      (if
	  (with-helm-buffer helm-ff-transformer-show-only-basename)
	  (cons
	   (propertize
	    (helm-basename c)
	    'face 'helm-ff-file)
	   c)
	(propertize c 'face 'helm-ff-file)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** match-part
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (c)
      (if
	  (with-helm-buffer helm-ff-transformer-show-only-basename)
	  (helm-basename c)
	c))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** root-dir
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

  See parent class for this slot's documentation.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))
 ((source helm-type-file))
 :before ((source helm-type-file))
 :after ((source helm-browse-project-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-file-cache

[[./helm-figures/helm-file-cache.png]]

#+hcindex: helm-file-cache

#+hcindex: helm-source-in-buffer

#+hcindex: helm-type-file

- *parents* ::

  - [[*class: helm-source-in-buffer]]

  - [[*class: helm-type-file]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (require 'filecache))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-candidates-in-buffer

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring-no-properties

- :documentation

  See parent class for this slot's documentation.

** match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(identity)

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** search
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(helm-candidates-in-buffer-search-default-fn)

- :documentation

  See parent class for this slot's documentation.

** search-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** volatile
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))
 ((source helm-type-file))
 :before ((source helm-type-file))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-recentf-source

[[./helm-figures/helm-recentf-source.png]]

#+hcindex: helm-recentf-source

#+hcindex: helm-source-sync

#+hcindex: helm-type-file

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-file]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (require 'recentf)
      (when helm-turn-on-recentf
	(recentf-mode 1)))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil recentf-list)
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-part
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (candidate)
      (if
	  (or helm-ff-transformer-show-only-basename helm-recentf--basename-flag)
	  (helm-basename candidate)
	candidate))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** pattern-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-recentf-pattern-transformer

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-ff-kill-or-find-buffer-fname

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-file))
 :before ((source helm-type-file))
 :after ((source helm-recentf-source))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-files-in-current-dir-source

[[./helm-figures/helm-files-in-current-dir-source.png]]

#+hcindex: helm-files-in-current-dir-source

#+hcindex: helm-source-sync

#+hcindex: helm-type-file

- *parents* ::

  - [[*class: helm-source-sync]]

  - [[*class: helm-type-file]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (with-helm-current-buffer
	(let
	    ((dir
	      (helm-current-directory)))
	  (when
	      (file-accessible-directory-p dir)
	    (directory-files dir t)))))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** fuzzy-match
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** match-dynamic
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** match-part
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (candidate)
      (if
	  (or helm-ff-transformer-show-only-basename helm-recentf--basename-flag)
	  (helm-basename candidate)
	candidate))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** match-strict
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** migemo
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** pattern-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-recentf-pattern-transformer

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))
 ((source helm-type-file))
 :before ((source helm-type-file))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-grep-class

[[./helm-figures/helm-grep-class.png]]

#+hcindex: helm-grep-class

#+hcindex: helm-source-async

- *parents* ::

  - [[*class: helm-source-async]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-actions

- :documentation

  See parent class for this slot's documentation.

** after-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-after-init-hook

- :documentation

  See parent class for this slot's documentation.

** backend
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    The grep backend that will be used.
    It is actually used only as an internal flag
    and doesn't set the backend by itself.
    You probably don't want to modify this.

** before-init-hook
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-before-init-hook

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  9999

- :documentation

  See parent class for this slot's documentation.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-collect-candidates

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-grep-fc-transformer

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-help-message

- :documentation

  See parent class for this slot's documentation.

** history
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-history

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-grep-map

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** pcre
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

    Backend is using pcre regexp engine when non-nil.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-persistent-action

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Jump to line (~C-u~ Record in mark ring)"

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  2

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))
 ((source helm-grep-class))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-grep-ag-class

[[./helm-figures/helm-grep-ag-class.png]]

#+hcindex: helm-grep-ag-class

#+hcindex: helm-source-async

- *parents* ::

  - [[*class: helm-source-async]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-actions

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  99999

- :documentation

  See parent class for this slot's documentation.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-grep-fc-transformer

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-help-message

- :documentation

  See parent class for this slot's documentation.

** history
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-ag-history

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-grep-map

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** pcre
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

    Backend is using pcre regexp engine when non--nil.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-persistent-action

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Jump to line (~C-u~ Record in mark ring)"

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  2

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))
 ((source helm-grep-ag-class))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-gid-source

[[./helm-figures/helm-gid-source.png]]

#+hcindex: helm-gid-source

#+hcindex: helm-source-async

- *parents* ::

  - [[*class: helm-source-async]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (helm-make-actions "Find File" 'helm-grep-action "Find file other frame" 'helm-grep-other-frame "Save results in grep buffer" 'helm-grep-save-results "Find file other window" 'helm-grep-other-window)
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  99999

- :documentation

  See parent class for this slot's documentation.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-gid-candidates-process

- :documentation

  See parent class for this slot's documentation.

** db-dir
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

   Location of ID file.

** filtered-candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-gid-filtered-candidate-transformer

- :documentation

  See parent class for this slot's documentation.

** header-name
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (name)
      (concat name " ["
	      (helm-get-attr 'db-dir)
	      "]"))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-help-message

- :documentation

  See parent class for this slot's documentation.

** history
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-history

- :documentation

  See parent class for this slot's documentation.

** nohighlight
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-grep-persistent-action

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  2

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-imenu-source

[[./helm-figures/helm-imenu-source.png]]

#+hcindex: helm-imenu-source

#+hcindex: helm-source-sync

- *parents* ::

  - [[*class: helm-source-sync]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu-action

- :documentation

  See parent class for this slot's documentation.

** candidate-transformer
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu-transformer

- :documentation

  See parent class for this slot's documentation.

** candidates
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu-candidates

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  helm-imenu-map

- :documentation

  See parent class for this slot's documentation.

** nomark
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  t

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-imenu-persistent-action

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Show this entry"

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-sync))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-info-source

[[./helm-figures/helm-info-source.png]]

#+hcindex: helm-info-source

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-info-init

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  '(("Goto node" . helm-info-goto))

- :documentation

  See parent class for this slot's documentation.

** display-to-real
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-info-display-to-real

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'buffer-substring

- :documentation

  See parent class for this slot's documentation.

** info-file
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-locate-override-inheritor

[[./helm-figures/helm-locate-override-inheritor.png]]

#+hcindex: helm-locate-override-inheritor

#+hcindex: helm-type-file

#+hcindex: helm-locate-source

- *parents* ::

  - [[*class: helm-type-file]]

- *children* ::

  - [[*class: helm-locate-source]]

The following are some interesting slots of this class. Note that not all slots are shown here.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-type-file))
 :before ((source helm-type-file))
 :after ((source helm-locate-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-locate-source

[[./helm-figures/helm-locate-source.png]]

#+hcindex: helm-locate-source

#+hcindex: helm-source-async

#+hcindex: helm-locate-override-inheritor

- *parents* ::

  - [[*class: helm-source-async]]

  - [[*class: helm-locate-override-inheritor]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-locate-initial-setup

- :documentation

  See parent class for this slot's documentation.

** candidate-number-limit
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  9999

- :documentation

  See parent class for this slot's documentation.

** candidates-process
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-locate-init

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-locate

- :documentation

  See parent class for this slot's documentation.

** history
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-file-name-history

- :documentation

  See parent class for this slot's documentation.

** multimatch
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-ff-kill-or-find-buffer-fname

- :documentation

  See parent class for this slot's documentation.

** redisplay
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (progn helm-locate-fuzzy-sort-fn)
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** requires-pattern
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  3

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm-source-get-action-from-type~:

 ((object helm-type-file))

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-async))
 ((source helm-type-file))
 :before ((source helm-type-file))
 :after ((source helm-locate-override-inheritor))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-locate-subdirs-source

[[./helm-figures/helm-locate-subdirs-source.png]]

#+hcindex: helm-locate-subdirs-source

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** basedir
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** data
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #'helm-locate-init-subdirs

- :documentation

  See parent class for this slot's documentation.

** group
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-locate

- :documentation

  See parent class for this slot's documentation.

** subdir
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-moccur-class

[[./helm-figures/helm-moccur-class.png]]

#+hcindex: helm-moccur-class

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** buffer-name
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** moccur-buffers
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  nil

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* class: helm-semantic-source

[[./helm-figures/helm-semantic-source.png]]

#+hcindex: helm-semantic-source

#+hcindex: helm-source-in-buffer

- *parents* ::

  - [[*class: helm-source-in-buffer]]

- *children* ::

The following are some interesting slots of this class. Note that not all slots are shown here.

** init
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda nil
      (helm-semantic--maybe-set-needs-update)
      (setq helm-semantic--tags-cache
	    (semantic-fetch-tags))
      (with-current-buffer
	  (helm-candidate-buffer 'global)
	(let
	    ((major-mode
	      (with-helm-current-buffer major-mode)))
	  (helm-semantic--fetch-candidates helm-semantic--tags-cache 0))))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-semantic-default-action

- :documentation

  See parent class for this slot's documentation.

** get-line
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'buffer-substring

- :documentation

  See parent class for this slot's documentation.

** help-message
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-semantic-help-message

- :documentation

  See parent class for this slot's documentation.

** keymap
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  'helm-semantic-map

- :documentation

  See parent class for this slot's documentation.

** persistent-action
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  #+begin_src emacs-lisp
    (lambda
      (elm)
      (helm-semantic-default-action elm t)
      (helm-highlight-current-line))
  #+end_src

- :documentation

  See parent class for this slot's documentation.

** persistent-help
:PROPERTIES:
:UNNUMBERED: notoc
:END:

- :initform

  "Show this entry"

- :documentation

  See parent class for this slot's documentation.

** Specialized Methods:
:PROPERTIES:
:UNNUMBERED: notoc
:END:

~helm--setup-source~:

 ((source helm-source))
 :before ((source helm-source))
 ((source helm-source-in-buffer))

~helm-setup-user-source~:

 ((source helm-source))

* Main Index
:PROPERTIES:
:INDEX:    cp
:DESCRIPTION: An index of Helm-Classes's concepts and features.
:END:

* Key Index
:PROPERTIES:
:DESCRIPTION: Key bindings and where they are described.
:INDEX:    ky
:END:

* Command and Function Index
:PROPERTIES:
:DESCRIPTION: Command names and some internal functions.
:INDEX:    fn
:END:

* Variable Index
:PROPERTIES:
:DESCRIPTION: Variables mentioned in the manual.
:INDEX:    vr
:END:

This is not a complete index of variables and faces, only the ones
that are mentioned in the manual.  For a more complete list, use
{{{kbd(M-x org-customize)}}} and then click yourself through the tree.

* Export Setup                                                          :noexport:

#+setupfile: doc-setup.org
#+options: H:4
#+export_file_name: helm-classes.texi
#+texinfo_dir_category: Emacs Add-ons
#+texinfo_dir_title: Helm Classes: (helm-classes)
#+texinfo_dir_desc: Helm Classes

* Footnotes

#+STARTUP: showeverything
#+STARTUP: inlineimages
#+EXCLUDE_TAGS: TOC_4

# (info (org-texinfo-export-to-info))

* Class Index
:PROPERTIES:
:DESCRIPTION: Index of Helm Classes
:INDEX: hc
:END:
#+texinfo: @printindex hc
